#include <iostream>
#include <string>
#include <vector>
using namespace std;
typedef long long ll;
#define debug(x) cout << (#x) << " = " << (x) << endl;

void append_edge(bool ** m, int a, int b) {
    m[a][b] = true;
    m[b][a] = true;
}

bool has_way(bool ** m, bool * v, int a, int b, int side) {
    if (!v[a]) {
        v[a] = true;
        if (a == b) {
            return true;
        }
        for (int i = 0; i < side; ++i) {
            if (m[a][i] && has_way(m, v, i, b, side))
                return true;
        }
    }
    return false;
}

int main() {
    int n, m, k;
    cin >> n >> m >> k;
    bool ** friendships = new bool*[n];
    bool ** races = new bool*[n];
    for (int i = 0; i < n; ++i) {
        friendships[i] = new bool[n];
        races[i] = new bool[n];
        for (int j = 0; j < n; ++j) {
            friendships[i][j] = false;
            races[i][j] = false;
        }
    }
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        append_edge(friendships, a - 1, b - 1);
    }

    for (int i = 0; i < k; ++i) {
        int a, b;
        cin >> a >> b;
        append_edge(races, a - 1, b - 1);
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        char kind;
        cin >> kind;
        int a, b;

        switch (kind) {
            case 'T': {
                cin >> a >> b;
                append_edge(races, a - 1, b - 1);
                break;
            }
            case 'F': {
                cin >> a >> b;
                append_edge(friendships, a - 1, b - 1);
                break;
            }
            case '?': {
                cin >> a; // v
                a -= 1;
                int cnt = 0;
                for (int j = 0; j < n; ++j) {
                    if (friendships[a][j]) {// if they are friends
                        bool v[n] = {0};
                        if (has_way(races, v, a, j, n)) {
                            cnt += 1;
                        }
                    }
                }
                cout << cnt << endl;
                break;
            }
        }
    }
}