#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int N = 2e5 + 7;
const int L = 20;

int p[N], sz[N];

void build(int n) {
	for (int i = 0; i < n; i++) {
		p[i] = i;
		sz[i] = 1;
	}
}

int get_par(int k) {
	if (k == p[k]) return k;
	return p[k] = get_par(p[k]);
}

void merge(int a, int b) {
	a = get_par(a); b = get_par(b);
	if (a == b) return;
	if (sz[a] < sz[b]) swap(a, b);
	sz[a] += sz[b];
	p[b] = a;
}

vector<pair<int, int>> g[N];
int tm = 0;
int tin[N], tout[N], pr[N][L], mx[N][L];
bool used[N];

void dfs(int v, pair<int, int> last = { -1, -1 }) {
	tin[v] = tm++;
	used[v] = true;
	if (last.first == -1) {
		pr[v][0] = v, mx[v][0] = 0;
	}
	else {
		pr[v][0] = last.first, mx[v][0] = last.second;
	}
	for (int i = 1; i < L; i++) {
		pr[v][i] = pr[pr[v][i - 1]][i - 1];
		mx[v][i] = max(mx[v][i - 1], mx[pr[v][i - 1]][i - 1]);
	}
	for (auto u : g[v]) {
		if (u.first == last.first) continue;
		dfs(u.first, { v, u.second });
	}
	tout[v] = tm++;
}

bool upper(int a, int b) {
	return tin[a] <= tin[b] && tout[b] <= tout[a];
}

int get(int a, int b) {
	int ans1 = -1, ans2 = -1;
	if (!upper(a, b)) {
		for (int i = L - 1; i >= 0; i--) {
			if (!upper(pr[a][i], b)) {
				ans1 = max(ans1, mx[a][i]);
				a = pr[a][i];
			}
		}
		ans1 = max(ans1, mx[a][0]);
	}
	if (!upper(b, a)) {
		for (int i = L - 1; i >= 0; i--) {
			if (!upper(pr[b][i], a)) {
				ans2 = max(ans2, mx[b][i]);
				b = pr[b][i];
			}
		}
		ans2 = max(ans2, mx[b][0]);
	}
	return max(ans1, ans2);
}

int main() {
	int n, m, k;
	cin >> n >> m >> k;
	vector<pair<pair<int, int>, int>> f;
	vector<pair<pair<int, int>, int>> ed;
	for (int i = 0; i < m; i++) {
		int a, b; cin >> a >> b; a--; b--;
		f.push_back({ {a, b}, 0 });
	}
	for (int i = 0; i < k; i++) {
		int a, b; cin >> a >> b;  a--; b--;
		ed.push_back({ {a, b}, 0 });
	}
	int q; cin >> q;
	vector<pair<int, int>> qu;
	for (int i = 0; i < q; i++) {
		char c; cin >> c;
		if (c == 'T') {
			int a, b; cin >> a >> b; a--; b--;
			ed.push_back({ {a, b}, i + 1});
		}
		else if (c == 'F') {
			int a, b; cin >> a >> b; a--; b--;
			f.push_back({ {a, b}, i + 1});
		}
		else {
			int t; cin >> t; t--;
			qu.push_back({ t, i + 1});
		}
	}
	sort(ed.begin(), ed.end(), [](pair<pair<int, int>, int> x, pair<pair<int, int>, int> y) {return x.second < y.second; });
	build(n);
	fill(used, used + n, false);
	for (auto u : ed) {
		if (get_par(u.first.first) != get_par(u.first.second)) {
			g[u.first.first].push_back({ u.first.second, u.second });
			g[u.first.second].push_back({ u.first.first, u.second });
		}
		merge(u.first.first, u.first.second);
	}
	for (int i = 0; i < n; i++) {
		if (!used[i]) dfs(i);
	}
	vector<pair<int, int>> ev;
	for (auto u : f) {
		int h = -1;
		if (get_par(u.first.first) != get_par(u.first.second)) h = u.second;
		else h = max(get(u.first.first, u.first.second), u.second);
		ev.push_back({ h, u.first.first });
		ev.push_back({ h, u.first.second });
	}
	sort(ev.begin(), ev.end());
	vector<int> ans(n);
	int t = 0;
	for (auto u : qu) {
		while (t < ev.size() && ev[t].first < u.second) {
			ans[ev[t].second]++;
			t++;
		}
		cout << ans[u.first] << "\n";
	}
	return 0;
}