#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int N = 25;
const int M = 4e7;

int n, m;
int a[N];
int cnt[M];
int precalc[1 << N];

int sum(int x, int y) {
	x += y;
	if (x >= m) {
		x -= m;
	}
	return x;
}

void build_precalc() {
	for (int i = 0; i < n; ++i) {
		precalc[1 << i] = a[i];
	}
	for (int i = 1; i < (1 << n); ++i) {
		int mask = (i & (i - 1));
		if (mask) {
			precalc[i] = sum(precalc[i ^ mask], precalc[mask]);
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		a[i] %= m;
	}
	build_precalc();
	fill(cnt, cnt + m, -1);
	int a = -1, b = -1;
	for (int mask = 0; mask < (1 << n); ++mask) {
		int fv = precalc[mask];
		if (cnt[fv] == -1) {
			cnt[fv] = mask;
		}
		else {
			a = (cnt[fv] ^ (cnt[fv] & mask));
			b = (mask ^ (cnt[fv] & mask));
			break;
		}
	}
	if (a == -1) {
		cout << "-1\n";
	}
	else {
		vector<int> ans1, ans2;
		for (int i = 0; i < n; ++i) {
			if (1 << i & a) {
				ans1.push_back(i);
			}
			if (1 << i & b) {
				ans2.push_back(i);
			}
		}
		cout << ans1.size() << '\n';
		for (int i : ans1) {
			cout << i + 1 << ' ';
		}
		cout << '\n';
		cout << ans2.size() << '\n';
		for (int i : ans2) {
			cout << i + 1 << ' ';
		}
		cout << '\n';
	}
	return 0;
}