#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

#define int long long

const int N = 3e5;

struct DSU {
	vector<int> p, h;
	vector<pair<int, int>> stack;

	int find(int x) { return x == p[x] ? x : find(p[x]); }

	void join(int x, int y) {
		x = find(x);
		y = find(y);
		if (h[x] > h[y]) {
			swap(x, y);
		}
		p[x] = y;
		if (h[x] == h[y]) {
			++h[y];
			stack.push_back({ x, +1 });
		}
		else {
			stack.push_back({ x, 0 });
		}
	}

	void undo() {
		int x = stack.back().first;
		int d = stack.back().second;
		h[p[x]] -= d;
		p[x] = x;
		stack.pop_back();
	}

	bool con(int x, int y) { return find(x) == find(y); }

	DSU() {}
	DSU(int n) : p(n), h(n, 1) {
		for (int x = 0; x < n; ++x) {
			p[x] = x;
		}
	}
};

int n;
int a[N];
pair<int, int> b[N];
int dp1[N], dp2[N];
int dp[N];

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> b[i].first;
		b[i].second = i;
	}
	sort(b, b + n);
	for (int i = 0, cur = 0; i < n; ++i) {
		if (i && b[i].first != b[i - 1].first) {
			++cur;
		}
		a[b[i].second] = cur;
	}
	DSU dsu(n);
	for (int i = n - 2, j = n - 2; i >= 0; i -= 2) {
		while (i <= j && dsu.con(a[i], a[i + 1])) {
			if (a[i] != a[i + 1]) {
				dsu.undo();
			}
			j -= 2;
		}
		dsu.join(a[i], a[i + 1]);
		dp1[i] = j;
	}
	dsu = DSU(n);
	for (int i = n - 3, j = n - 3; i >= 0; i -= 2) {
		while (i <= j && dsu.con(a[i], a[i + 1])) {
			if (a[i] != a[i + 1]) {
				dsu.undo();
			}
			j -= 2;
		}
		dsu.join(a[i], a[i + 1]);
		dp2[i] = j;
	}
	int ans = 0;
	for (int i = n - 1; i >= 0; --i) {
		if (i == n - 1 && b[i].first == 0) {
			dp[i] = 1;
		}
		else if (i == n - 2 && b[i].first == 0) {
			dp[i] = 1 + dp[i + 1];
		}
		else if (n - 2 - (i + 1) & 1) {
			if (dp2[i + 1] + 2 >= i + 1 + 2 * b[i].first) {
				dp[i] = 1 + dp[i + 1 + 2 * b[i].first];
			}
		}
		else {
			if (dp1[i + 1] + 2 >= i + 1 + 2 * b[i].first) {
				dp[i] = 1 + dp[i + 1 + 2 * b[i].first];
			}
		}
		ans += dp[i];
	}
	cout << ans << '\n';
	return 0;
}